
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/time.h>
#include <termios.h>  

#include <errno.h>

#include <pthread.h> 

/* Interface types */

#define ADC_NONE	0
#define ADC_ADIO	1

#define NUM_CHANNELS	6

static int controlbytes[NUM_CHANNELS]={0x8c,0x9c,0xac,0xbc,0xcc,0xdc}; 

struct adcreader {
                 pthread_t thread;
		 pthread_mutex_t adcread_mutex;
                 int enabled;
                 int fd;
                 struct termios oldtio; 
		 float values[NUM_CHANNELS];
		};

/* Prototypes */

int init_adcreader(struct adcreader *adc, char *device, int type);
int start_adcreader(struct adcreader *adc); 
int stop_adcreader(struct adcreader *adc); 

int adcreader_lock(struct adcreader *adc);
int adcreader_unlock(struct adcreader *adc);
