
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/time.h>
#include <errno.h>
#include <pthread.h> 
#include <termios.h>
#include <time.h>

#define _POSIX_SOURCE 1 

/* DVD types */

#define DVD_NONE	0
#define DVD_PHILIPS	1
#define DVD_PIONEER	2

#define DVDCOMMANDTIMEOUT	1.1

static char *dvd_names[3] = {"No","Philips","Pioneer"};

#define BUFFERLEN	256

struct dvdcontroller {
	         pthread_t thread;
		 pthread_mutex_t dvdcontrol_mutex;
                 int enabled;
                 int fd;
                 char device[BUFFERLEN];
                 int type;
                 int title;
                 struct termios oldtio;
                 char command[BUFFERLEN];
		};

/* Prototypes */

int init_dvdcontroller(struct dvdcontroller *dvd, char *device, int type);
int start_dvdcontroller(struct dvdcontroller *dvd); 
int stop_dvdcontroller(struct dvdcontroller *dvd); 

int dvdcontroller_lock(struct dvdcontroller *dvd);
int dvdcontroller_unlock(struct dvdcontroller *dvd);

void DVDCommand_Init(struct dvdcontroller *dvd, int title);
void DVDCommand_Play(struct dvdcontroller *dvd, int chapter);

