
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/time.h>
#include <math.h>

#include <errno.h>

#include <pthread.h> 

#include "adcread.h"

/* Testmode settings */

#define JOY_NORMAL	1
#define JOY_MANUAL	2
#define JOY_CALIBRATE	3

#define NUM_AVERAGE	12
	
struct joyreader {
                 pthread_t thread;
		 pthread_mutex_t joyread_mutex;
		 struct adcreader *adc;
		 int channelx;
		 int channely;
                 int testmode;
		 float x;
		 float y;
		 float minu,maxu;
		 float minv,maxv;
		 float xfactor, yfactor;
		};

/* Prototypes */

int init_joyreader(struct joyreader *joy, struct adcreader *adc, int channelx, int channely);
int start_joyreader(struct joyreader *joy); 
int stop_joyreader(struct joyreader *joy); 

int joyreader_lock(struct joyreader *joy);
int joyreader_unlock(struct joyreader *joy);

