
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/time.h>
#include <termios.h>

#include <errno.h>

#include <pthread.h> 

#define LIGHT_NONE	0
#define LIGHT_CONRAD	1

#define LIGHTBUFFERLEN	256

struct lightcontroller {
 		 int enabled;
	         pthread_t lightcontrol_thread;
		 pthread_mutex_t lightcontrol_mutex;
                 int fd;
                 char device[LIGHTBUFFERLEN];
                 struct termios oldtio;
                 unsigned char value;
		};

/* Prototypes */

int init_lightcontroller(struct lightcontroller *light, char *device, int type);
int start_lightcontroller(struct lightcontroller *light); 
int stop_lightcontroller (struct lightcontroller *light);

int lightcontroller_lock(struct lightcontroller *light);
int lightcontroller_unlock(struct lightcontroller *light);
