#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/extensions/XShm.h>
#include <X11/extensions/xf86vmode.h>
#include <X11/keysym.h>

#include <sys/shm.h>
#include <sys/ipc.h>

#define RGB24RGB16(r,g,b) ( ( (((int)r >> 3) << 11) | (((int)g >> 2 ) << 5) | ((int)b >> 3) ) )

struct xwinbuffer {
	int width;
	int height;
	int maxx,maxy;
	int depth;
	Display* display_;
	GC gc_;
	Window wtwin_;
	XImage *shmimage;
	XShmSegmentInfo* shminfo;
        int vm_count,vm_smode, modeswitch;
        XF86VidModeModeInfo **vm_modelines;
      };

int setup_xwinbuffer(struct xwinbuffer *xwin, char *prgname, int width, int height, int depth);
int sync_xwinbuffer(struct xwinbuffer *xwin);
int keypoll_xwinbuffer (struct xwinbuffer *xwin, KeySym *key, int *button, int *mousex, int *mousey);
int close_xwinbuffer (struct xwinbuffer *xwin);

void hline (struct xwinbuffer *xwin, int x1, int x2, int y, int color);
void vline (struct xwinbuffer *xwin, int x, int y1, int y2, int color);
void drawchar (struct xwinbuffer *xwin, int x, int y, char c, int color);
void drawstring (struct xwinbuffer *xwin, int x, int y, char *s, int color);
void drawpixel(struct xwinbuffer *xwin, int x, int y, int color);
void drawline(struct xwinbuffer *xwin, int x1, int y1, int x2, int y2, int color);
void drawbox(struct xwinbuffer *xwin, int x1, int y1, int x2, int y2, int color);

void videoModeChange(struct xwinbuffer *xwin, int width, int height);
void videoModeReset(struct xwinbuffer *xwin);
